$mod52
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Matematicka knihovna pro 8051 pro vypocty v pohyblive
; radove carce
;
; Priklad vypoctu goniometrickych a cyklometrickych funkci
; Uhly jsou v radianech
;
; Program posila vysledky po seriove lince 9600 Bd
; Lze upravit zmenou konstant
; fp_stack je adresa pracovniho prostoru 31 bajtu
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++


fp_stack	equ	50h	;adresa odkladaciho prostoru (31B)


	ORG 100h
	MOV	SP,#30h
	MOV	TMOD,#20h
	mov	SCON,#52h
	MOV	TH1,#0fdh
	SETB	TR1		;linka 9600

	MOV	DPTR,#text	;nadpis
	LCALL	write


	MOV	20H,#0		;cislo - znamenko
	MOV	21H,#0H		;mantisa
	MOV	22H,#021h
	MOV	23H,#079H
	MOV	24H,#7cH	;exponent


;------------------
;Priklad vypoctu SIN(x)

	MOV	DPTR,#symbol_sin	;vypise symbol sinu
	LCALL	write			;napise symbol SIN
	MOV	R0,#20H			;adresa cisla
	LCALL	FP_PRINT		;napis cislo 0.8569
	MOV	DPTR,#symbol_equal
	LCALL	write			;napise =

	MOV	R0,#20H			;adresa cisla
	LCALL	FP_SIN			;spocte sinus
	LCALL	FP_PRINT		;napise vysledek
;----------------	
	MOV	DPTR,#crlf
	LCALL	write			;odradkuje
;----------------
;Priklad vypoctu COS(x)

	MOV	DPTR,#symbol_cos	;vypise symbol cosinu
	LCALL	write			;napise symbol COS
	MOV	R0,#20H			;adresa cisla
	LCALL	FP_PRINT		;napis cislo
	MOV	DPTR,#symbol_equal
	LCALL	write			;napise =

	MOV	R0,#20H			;adresa cisla
	LCALL	FP_COS			;spocte cosinus
	LCALL	FP_PRINT		;napise vysledek
;----------------	
	MOV	DPTR,#crlf
	LCALL	write			;odradkuje
;----------------
;Priklad vypoctu LN(x)

	MOV	20H,#0		;cislo - znamenko
	MOV	21H,#0H		;mantisa
	MOV	22H,#021h
	MOV	23H,#079H
	MOV	24H,#7dH	;exponent


	MOV	DPTR,#symbol_ln		;vypise symbol logaritmu
	LCALL	write			;napise symbol LN
	MOV	R0,#20H			;adresa cisla
	LCALL	FP_PRINT		;napis cislo
	MOV	DPTR,#symbol_equal
	LCALL	write			;napise =

	MOV	R0,#20H			;adresa cisla
	LCALL	FP_LN			;spocte logaritmus
	LCALL	FP_PRINT		;napise vysledek
;----------------	
	MOV	DPTR,#crlf
	LCALL	write			;odradkuje
;----------------
;Priklad vypoctu EXP(x)

	MOV	DPTR,#symbol_exp	;vypise symbol exponencialni funkce
	LCALL	write			;napise symbol EXP
	MOV	R0,#20H			;adresa cisla
	LCALL	FP_PRINT		;napis cislo
	MOV	DPTR,#symbol_equal
	LCALL	write			;napise =

	MOV	R0,#20H			;adresa cisla
	LCALL	FP_EXP			;spocte E^x
	LCALL	FP_PRINT		;napise vysledek


	SJMP	$

;--------------
;Podprogram - vypise symbol operace

write:
	CLR	A
	JNB	TI,$		;ceka na uvolneni linky
	MOVC	A,@A+DPTR	;precte znak z tabulky
	INC	DPTR		;posun v tabulce
	JZ	write_end	;je konec ?
	MOV	SBUF,A		;vysli znak
	CLR	TI
	SJMP	write		;opakuj
write_end:
	RET			;navrat
;---------------
;Tabulky symbolu
text:	db	'(C) 1998  NEGATRON         ing. Martin Hankovec ',10,13,10,13
	db 	'Toto je doplnek matematicke knihovny umoznujici vypocty techto funkci:',10,13
	db	'SIN (X), COS (X), TAN(X), EXP(X), LN(X)',10,13
	db	'Blizsi informace jsou v navodu.',10,13,10,13,0

symbol_sin:
	db	' SIN ',0
symbol_equal:
	db	' = ',0
symbol_cos:
	db	' COS ',0
symbol_TAN:
	db	' TAN ',0
symbol_LN:
	db	' LN ',0
symbol_EXP:
	db	' EXP ',0
crlf:	db	10,13,0

$include(fp_math.inc)
$include(fp_func.inc)

	END