$mod52
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Matematicka knihovna pro 8051 pro vypocty v pohyblive
; radove carce
;
; Priklad vypoctu beznych matematickych operaci
;
; Program posila vysledky po seriove lince 9600 Bd
; Lze upravit zmenou konstant
; fp_stack je adresa pracovniho prostoru 16 bajtu
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++


fp_stack	equ	60h	;adresa odkladaciho prostoru (16B)


	ORG 100h
	MOV	SP,#40h
	MOV	TMOD,#20h
	mov	SCON,#52h
	MOV	TH1,#0fdh
	SETB	TR1

	MOV	DPTR,#text	;nadpis
	LCALL	write


	MOV	20H,#0		;1.cislo - znamenko
	MOV	21H,#02FH	;mantisa
	MOV	22H,#0EFh
	MOV	23H,#0D8H
	MOV	24H,#7AH	;exponent

	MOV	25H,#0FFH	;2.cislo - znamenko
	MOV	26H,#0		;mantisa
	MOV	27H,#0
	MOV	28H,#055H
	MOV	29H,#7FH	;exponent

;------------------
;Priklad nasobeni

	MOV	R0,#20H			;adresa 1.cisla
	LCALL	FP_PRINT		;napis cislo

	MOV	DPTR,#symbol_mul	;vypise symbol nasobeni
	LCALL	write			;napise symbol

	MOV	R0,#25H			;adresa 2.cisla
	LCALL	FP_PRINT		;napis cislo

	MOV	DPTR,#symbol_equal	;vypise symbol nasobeni
	LCALL	write			;napise symbol

	MOV	R0,#20h			;adresa 1. argumentu
	MOV	R1,#25h			;adresa 2. argumentu
	LCALL	FP_MUL			;vynasob cisla
	LCALL	FP_PRINT		;vypis vysledek	

	MOV	DPTR,#crlf
	LCALL	write			;odradkuje

;----------------
;Priklad deleni

	MOV	25H,#0		;2.cislo - znamenko
	MOV	26H,#07H	;mantisa
	MOV	27H,#060H
	MOV	28H,#054H
	MOV	29H,#7DH	;exponent

	MOV	R0,#20H			;adresa 1.cisla
	LCALL	FP_PRINT		;napis cislo

	MOV	DPTR,#symbol_div	;vypise symbol nasobeni
	LCALL	write			;napise symbol

	MOV	R0,#25H			;adresa 2.cisla
	LCALL	FP_PRINT		;napis cislo

	MOV	DPTR,#symbol_equal	;vypise symbol nasobeni
	LCALL	write			;napise symbol

	MOV	R0,#20h			;adresa 1. argumentu
	MOV	R1,#25h			;adresa 2. argumentu
	LCALL	FP_DIV			;vydel cisla
	LCALL	FP_PRINT		;vypis vysledek	

	MOV	DPTR,#crlf
	LCALL	write			;odradkuje
	
;----------------
;Priklad souctu

	MOV	25H,#0FFH		;2.cislo - znamenko
	MOV	26H,#0C0H	;mantisa
	MOV	27H,#012H
	MOV	28H,#05CH
	MOV	29H,#7AH	;exponent

	MOV	R0,#20H			;adresa 1.cisla
	LCALL	FP_PRINT		;napis cislo

	MOV	DPTR,#symbol_add	;vypise symbol nasobeni
	LCALL	write			;napise symbol

	MOV	R0,#25H			;adresa 2.cisla
	LCALL	FP_PRINT		;napis cislo

	MOV	DPTR,#symbol_equal	;vypise symbol nasobeni
	LCALL	write			;napise symbol

	MOV	R0,#20h			;adresa 1. argumentu
	MOV	R1,#25h			;adresa 2. argumentu
	LCALL	FP_ADD			;vydel cisla
	LCALL	FP_PRINT		;vypis vysledek	

	MOV	DPTR,#crlf
	LCALL	write			;odradkuje

;----------------
;Priklad rozdilu

	MOV	25H,#0		;2.cislo - znamenko
	MOV	26H,#0AH	;mantisa
	MOV	27H,#070H
	MOV	28H,#0ADH
	MOV	29H,#7EH	;exponent

	MOV	R0,#20H			;adresa 1.cisla
	LCALL	FP_PRINT		;napis cislo

	MOV	DPTR,#symbol_subb	;vypise symbol nasobeni
	LCALL	write			;napise symbol

	MOV	R0,#25H			;adresa 2.cisla
	LCALL	FP_PRINT		;napis cislo

	MOV	DPTR,#symbol_equal	;vypise symbol nasobeni
	LCALL	write			;napise symbol

	MOV	R0,#20h			;adresa 1. argumentu
	MOV	R1,#25h			;adresa 2. argumentu
	LCALL	FP_SUBB			;vydel cisla
	LCALL	FP_PRINT		;vypis vysledek	

	MOV	DPTR,#crlf
	LCALL	write			;odradkuje

	SJMP	$

;--------------
;Podprogram - vypise symbol operace

write:
	CLR	A
	JNB	TI,$		;ceka na uvolneni linky
	MOVC	A,@A+DPTR	;precte znak z tabulky
	INC	DPTR		;posun v tabulce
	JZ	write_end	;je konec ?
	MOV	SBUF,A		;vysli znak
	CLR	TI
	SJMP	write		;opakuj
write_end:
	RET			;navrat
;---------------
;Tabulky symbolu
text:	db	'(C) 1998  NEGATRON         ing. Martin Hankovec ',10,13,10,13
	db 	'Toto je matematicka knihovna, ktera umoznuje vypocty v plovouci radove',10,13
	db	'carce. Umoznuje scitani, odcitani, nasobeni, deleni a dalsi operace uvedene',10,13
	db	'v navodu. Zde je nekolik prikladu:',10,13,10,13,0

symbol_mul:
	db	' * ',0
symbol_equal:
	db	' = ',0
symbol_div:
	db	' / ',0
symbol_add:
	db	' + ',0
symbol_subb:
	db	' - ',0
crlf:	db	10,13,0

$include(fp_math.inc)


	END